# coding: utf-8

"""
    OrderCloud

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 1.0
    Contact: ordercloud@four51.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class CreditCardApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def buyers_buyer_id_creditcards_assignments_get(self, buyer_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_assignments_get(buyer_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str credit_card_id: ID of the credit card.
        :param str user_id: ID of the user.
        :param str user_group_id: ID of the user group.
        :param str level: Level of the credit card.
        :param int page: Page of the credit card.
        :param int page_size: Page size of the credit card.
        :return: ListCreditCardAssignment
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.buyers_buyer_id_creditcards_assignments_get_with_http_info(buyer_id, **kwargs)
        else:
            (data) = self.buyers_buyer_id_creditcards_assignments_get_with_http_info(buyer_id, **kwargs)
            return data

    def buyers_buyer_id_creditcards_assignments_get_with_http_info(self, buyer_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_assignments_get_with_http_info(buyer_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str credit_card_id: ID of the credit card.
        :param str user_id: ID of the user.
        :param str user_group_id: ID of the user group.
        :param str level: Level of the credit card.
        :param int page: Page of the credit card.
        :param int page_size: Page size of the credit card.
        :return: ListCreditCardAssignment
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['buyer_id', 'credit_card_id', 'user_id', 'user_group_id', 'level', 'page', 'page_size']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method buyers_buyer_id_creditcards_assignments_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'buyer_id' is set
        if ('buyer_id' not in params) or (params['buyer_id'] is None):
            raise ValueError("Missing the required parameter `buyer_id` when calling `buyers_buyer_id_creditcards_assignments_get`")

        resource_path = '/buyers/{buyerID}/creditcards/assignments'.replace('{format}', 'json')
        path_params = {}
        if 'buyer_id' in params:
            path_params['buyerID'] = params['buyer_id']

        query_params = {}
        if 'credit_card_id' in params:
            query_params['creditCardID'] = params['credit_card_id']
        if 'user_id' in params:
            query_params['userID'] = params['user_id']
        if 'user_group_id' in params:
            query_params['userGroupID'] = params['user_group_id']
        if 'level' in params:
            query_params['level'] = params['level']
        if 'page' in params:
            query_params['page'] = params['page']
        if 'page_size' in params:
            query_params['pageSize'] = params['page_size']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ListCreditCardAssignment',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def buyers_buyer_id_creditcards_assignments_post(self, buyer_id, assignment, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_assignments_post(buyer_id, assignment, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param CreditCardAssignment assignment:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.buyers_buyer_id_creditcards_assignments_post_with_http_info(buyer_id, assignment, **kwargs)
        else:
            (data) = self.buyers_buyer_id_creditcards_assignments_post_with_http_info(buyer_id, assignment, **kwargs)
            return data

    def buyers_buyer_id_creditcards_assignments_post_with_http_info(self, buyer_id, assignment, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_assignments_post_with_http_info(buyer_id, assignment, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param CreditCardAssignment assignment:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['buyer_id', 'assignment']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method buyers_buyer_id_creditcards_assignments_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'buyer_id' is set
        if ('buyer_id' not in params) or (params['buyer_id'] is None):
            raise ValueError("Missing the required parameter `buyer_id` when calling `buyers_buyer_id_creditcards_assignments_post`")
        # verify the required parameter 'assignment' is set
        if ('assignment' not in params) or (params['assignment'] is None):
            raise ValueError("Missing the required parameter `assignment` when calling `buyers_buyer_id_creditcards_assignments_post`")

        resource_path = '/buyers/{buyerID}/creditcards/assignments'.replace('{format}', 'json')
        path_params = {}
        if 'buyer_id' in params:
            path_params['buyerID'] = params['buyer_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'assignment' in params:
            body_params = params['assignment']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def buyers_buyer_id_creditcards_credit_card_id_assignments_delete(self, buyer_id, credit_card_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_credit_card_id_assignments_delete(buyer_id, credit_card_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str credit_card_id: ID of the credit card. (required)
        :param str user_id: ID of the user.
        :param str user_group_id: ID of the user group.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.buyers_buyer_id_creditcards_credit_card_id_assignments_delete_with_http_info(buyer_id, credit_card_id, **kwargs)
        else:
            (data) = self.buyers_buyer_id_creditcards_credit_card_id_assignments_delete_with_http_info(buyer_id, credit_card_id, **kwargs)
            return data

    def buyers_buyer_id_creditcards_credit_card_id_assignments_delete_with_http_info(self, buyer_id, credit_card_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_credit_card_id_assignments_delete_with_http_info(buyer_id, credit_card_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str credit_card_id: ID of the credit card. (required)
        :param str user_id: ID of the user.
        :param str user_group_id: ID of the user group.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['buyer_id', 'credit_card_id', 'user_id', 'user_group_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method buyers_buyer_id_creditcards_credit_card_id_assignments_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'buyer_id' is set
        if ('buyer_id' not in params) or (params['buyer_id'] is None):
            raise ValueError("Missing the required parameter `buyer_id` when calling `buyers_buyer_id_creditcards_credit_card_id_assignments_delete`")
        # verify the required parameter 'credit_card_id' is set
        if ('credit_card_id' not in params) or (params['credit_card_id'] is None):
            raise ValueError("Missing the required parameter `credit_card_id` when calling `buyers_buyer_id_creditcards_credit_card_id_assignments_delete`")

        resource_path = '/buyers/{buyerID}/creditcards/{creditCardID}/assignments'.replace('{format}', 'json')
        path_params = {}
        if 'buyer_id' in params:
            path_params['buyerID'] = params['buyer_id']
        if 'credit_card_id' in params:
            path_params['creditCardID'] = params['credit_card_id']

        query_params = {}
        if 'user_id' in params:
            query_params['userID'] = params['user_id']
        if 'user_group_id' in params:
            query_params['userGroupID'] = params['user_group_id']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def buyers_buyer_id_creditcards_credit_card_id_delete(self, buyer_id, credit_card_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_credit_card_id_delete(buyer_id, credit_card_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str credit_card_id: ID of the credit card. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.buyers_buyer_id_creditcards_credit_card_id_delete_with_http_info(buyer_id, credit_card_id, **kwargs)
        else:
            (data) = self.buyers_buyer_id_creditcards_credit_card_id_delete_with_http_info(buyer_id, credit_card_id, **kwargs)
            return data

    def buyers_buyer_id_creditcards_credit_card_id_delete_with_http_info(self, buyer_id, credit_card_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_credit_card_id_delete_with_http_info(buyer_id, credit_card_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str credit_card_id: ID of the credit card. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['buyer_id', 'credit_card_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method buyers_buyer_id_creditcards_credit_card_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'buyer_id' is set
        if ('buyer_id' not in params) or (params['buyer_id'] is None):
            raise ValueError("Missing the required parameter `buyer_id` when calling `buyers_buyer_id_creditcards_credit_card_id_delete`")
        # verify the required parameter 'credit_card_id' is set
        if ('credit_card_id' not in params) or (params['credit_card_id'] is None):
            raise ValueError("Missing the required parameter `credit_card_id` when calling `buyers_buyer_id_creditcards_credit_card_id_delete`")

        resource_path = '/buyers/{buyerID}/creditcards/{creditCardID}'.replace('{format}', 'json')
        path_params = {}
        if 'buyer_id' in params:
            path_params['buyerID'] = params['buyer_id']
        if 'credit_card_id' in params:
            path_params['creditCardID'] = params['credit_card_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def buyers_buyer_id_creditcards_credit_card_id_get(self, buyer_id, credit_card_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_credit_card_id_get(buyer_id, credit_card_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str credit_card_id: ID of the credit card. (required)
        :return: CreditCard
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.buyers_buyer_id_creditcards_credit_card_id_get_with_http_info(buyer_id, credit_card_id, **kwargs)
        else:
            (data) = self.buyers_buyer_id_creditcards_credit_card_id_get_with_http_info(buyer_id, credit_card_id, **kwargs)
            return data

    def buyers_buyer_id_creditcards_credit_card_id_get_with_http_info(self, buyer_id, credit_card_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_credit_card_id_get_with_http_info(buyer_id, credit_card_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str credit_card_id: ID of the credit card. (required)
        :return: CreditCard
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['buyer_id', 'credit_card_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method buyers_buyer_id_creditcards_credit_card_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'buyer_id' is set
        if ('buyer_id' not in params) or (params['buyer_id'] is None):
            raise ValueError("Missing the required parameter `buyer_id` when calling `buyers_buyer_id_creditcards_credit_card_id_get`")
        # verify the required parameter 'credit_card_id' is set
        if ('credit_card_id' not in params) or (params['credit_card_id'] is None):
            raise ValueError("Missing the required parameter `credit_card_id` when calling `buyers_buyer_id_creditcards_credit_card_id_get`")

        resource_path = '/buyers/{buyerID}/creditcards/{creditCardID}'.replace('{format}', 'json')
        path_params = {}
        if 'buyer_id' in params:
            path_params['buyerID'] = params['buyer_id']
        if 'credit_card_id' in params:
            path_params['creditCardID'] = params['credit_card_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='CreditCard',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def buyers_buyer_id_creditcards_credit_card_id_patch(self, buyer_id, credit_card_id, card, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_credit_card_id_patch(buyer_id, credit_card_id, card, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str credit_card_id: ID of the credit card. (required)
        :param CreditCard card:  (required)
        :return: CreditCard
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.buyers_buyer_id_creditcards_credit_card_id_patch_with_http_info(buyer_id, credit_card_id, card, **kwargs)
        else:
            (data) = self.buyers_buyer_id_creditcards_credit_card_id_patch_with_http_info(buyer_id, credit_card_id, card, **kwargs)
            return data

    def buyers_buyer_id_creditcards_credit_card_id_patch_with_http_info(self, buyer_id, credit_card_id, card, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_credit_card_id_patch_with_http_info(buyer_id, credit_card_id, card, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str credit_card_id: ID of the credit card. (required)
        :param CreditCard card:  (required)
        :return: CreditCard
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['buyer_id', 'credit_card_id', 'card']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method buyers_buyer_id_creditcards_credit_card_id_patch" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'buyer_id' is set
        if ('buyer_id' not in params) or (params['buyer_id'] is None):
            raise ValueError("Missing the required parameter `buyer_id` when calling `buyers_buyer_id_creditcards_credit_card_id_patch`")
        # verify the required parameter 'credit_card_id' is set
        if ('credit_card_id' not in params) or (params['credit_card_id'] is None):
            raise ValueError("Missing the required parameter `credit_card_id` when calling `buyers_buyer_id_creditcards_credit_card_id_patch`")
        # verify the required parameter 'card' is set
        if ('card' not in params) or (params['card'] is None):
            raise ValueError("Missing the required parameter `card` when calling `buyers_buyer_id_creditcards_credit_card_id_patch`")

        resource_path = '/buyers/{buyerID}/creditcards/{creditCardID}'.replace('{format}', 'json')
        path_params = {}
        if 'buyer_id' in params:
            path_params['buyerID'] = params['buyer_id']
        if 'credit_card_id' in params:
            path_params['creditCardID'] = params['credit_card_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'card' in params:
            body_params = params['card']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'PATCH',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='CreditCard',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def buyers_buyer_id_creditcards_credit_card_id_put(self, buyer_id, credit_card_id, card, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_credit_card_id_put(buyer_id, credit_card_id, card, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str credit_card_id: ID of the credit card. (required)
        :param CreditCard card:  (required)
        :return: CreditCard
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.buyers_buyer_id_creditcards_credit_card_id_put_with_http_info(buyer_id, credit_card_id, card, **kwargs)
        else:
            (data) = self.buyers_buyer_id_creditcards_credit_card_id_put_with_http_info(buyer_id, credit_card_id, card, **kwargs)
            return data

    def buyers_buyer_id_creditcards_credit_card_id_put_with_http_info(self, buyer_id, credit_card_id, card, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_credit_card_id_put_with_http_info(buyer_id, credit_card_id, card, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str credit_card_id: ID of the credit card. (required)
        :param CreditCard card:  (required)
        :return: CreditCard
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['buyer_id', 'credit_card_id', 'card']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method buyers_buyer_id_creditcards_credit_card_id_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'buyer_id' is set
        if ('buyer_id' not in params) or (params['buyer_id'] is None):
            raise ValueError("Missing the required parameter `buyer_id` when calling `buyers_buyer_id_creditcards_credit_card_id_put`")
        # verify the required parameter 'credit_card_id' is set
        if ('credit_card_id' not in params) or (params['credit_card_id'] is None):
            raise ValueError("Missing the required parameter `credit_card_id` when calling `buyers_buyer_id_creditcards_credit_card_id_put`")
        # verify the required parameter 'card' is set
        if ('card' not in params) or (params['card'] is None):
            raise ValueError("Missing the required parameter `card` when calling `buyers_buyer_id_creditcards_credit_card_id_put`")

        resource_path = '/buyers/{buyerID}/creditcards/{creditCardID}'.replace('{format}', 'json')
        path_params = {}
        if 'buyer_id' in params:
            path_params['buyerID'] = params['buyer_id']
        if 'credit_card_id' in params:
            path_params['creditCardID'] = params['credit_card_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'card' in params:
            body_params = params['card']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='CreditCard',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def buyers_buyer_id_creditcards_get(self, buyer_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_get(buyer_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str search: Search of the credit card.
        :param list[str] search_on: Search on of the credit card.
        :param list[str] sort_by: Sort by of the credit card.
        :param int page: Page of the credit card.
        :param int page_size: Page size of the credit card.
        :return: ListCreditCard
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.buyers_buyer_id_creditcards_get_with_http_info(buyer_id, **kwargs)
        else:
            (data) = self.buyers_buyer_id_creditcards_get_with_http_info(buyer_id, **kwargs)
            return data

    def buyers_buyer_id_creditcards_get_with_http_info(self, buyer_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_get_with_http_info(buyer_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param str search: Search of the credit card.
        :param list[str] search_on: Search on of the credit card.
        :param list[str] sort_by: Sort by of the credit card.
        :param int page: Page of the credit card.
        :param int page_size: Page size of the credit card.
        :return: ListCreditCard
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['buyer_id', 'search', 'search_on', 'sort_by', 'page', 'page_size']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method buyers_buyer_id_creditcards_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'buyer_id' is set
        if ('buyer_id' not in params) or (params['buyer_id'] is None):
            raise ValueError("Missing the required parameter `buyer_id` when calling `buyers_buyer_id_creditcards_get`")

        resource_path = '/buyers/{buyerID}/creditcards'.replace('{format}', 'json')
        path_params = {}
        if 'buyer_id' in params:
            path_params['buyerID'] = params['buyer_id']

        query_params = {}
        if 'search' in params:
            query_params['search'] = params['search']
        if 'search_on' in params:
            query_params['searchOn'] = params['search_on']
        if 'sort_by' in params:
            query_params['sortBy'] = params['sort_by']
        if 'page' in params:
            query_params['page'] = params['page']
        if 'page_size' in params:
            query_params['pageSize'] = params['page_size']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ListCreditCard',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def buyers_buyer_id_creditcards_post(self, buyer_id, card, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_post(buyer_id, card, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param CreditCard card:  (required)
        :return: CreditCard
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.buyers_buyer_id_creditcards_post_with_http_info(buyer_id, card, **kwargs)
        else:
            (data) = self.buyers_buyer_id_creditcards_post_with_http_info(buyer_id, card, **kwargs)
            return data

    def buyers_buyer_id_creditcards_post_with_http_info(self, buyer_id, card, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.buyers_buyer_id_creditcards_post_with_http_info(buyer_id, card, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str buyer_id: ID of the buyer. (required)
        :param CreditCard card:  (required)
        :return: CreditCard
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['buyer_id', 'card']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method buyers_buyer_id_creditcards_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'buyer_id' is set
        if ('buyer_id' not in params) or (params['buyer_id'] is None):
            raise ValueError("Missing the required parameter `buyer_id` when calling `buyers_buyer_id_creditcards_post`")
        # verify the required parameter 'card' is set
        if ('card' not in params) or (params['card'] is None):
            raise ValueError("Missing the required parameter `card` when calling `buyers_buyer_id_creditcards_post`")

        resource_path = '/buyers/{buyerID}/creditcards'.replace('{format}', 'json')
        path_params = {}
        if 'buyer_id' in params:
            path_params['buyerID'] = params['buyer_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'card' in params:
            body_params = params['card']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='CreditCard',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))
