# coding: utf-8

"""
    OrderCloud

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 1.0
    Contact: ordercloud@four51.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class PriceScheduleApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def priceschedules_get(self, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_get(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str search: Search of the price schedule.
        :param list[str] search_on: Search on of the price schedule.
        :param list[str] sort_by: Sort by of the price schedule.
        :param int page: Page of the price schedule.
        :param int page_size: Page size of the price schedule.
        :return: ListPriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.priceschedules_get_with_http_info(**kwargs)
        else:
            (data) = self.priceschedules_get_with_http_info(**kwargs)
            return data

    def priceschedules_get_with_http_info(self, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_get_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str search: Search of the price schedule.
        :param list[str] search_on: Search on of the price schedule.
        :param list[str] sort_by: Sort by of the price schedule.
        :param int page: Page of the price schedule.
        :param int page_size: Page size of the price schedule.
        :return: ListPriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['search', 'search_on', 'sort_by', 'page', 'page_size']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method priceschedules_get" % key
                )
            params[key] = val
        del params['kwargs']

        resource_path = '/priceschedules'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'search' in params:
            query_params['search'] = params['search']
        if 'search_on' in params:
            query_params['searchOn'] = params['search_on']
        if 'sort_by' in params:
            query_params['sortBy'] = params['sort_by']
        if 'page' in params:
            query_params['page'] = params['page']
        if 'page_size' in params:
            query_params['pageSize'] = params['page_size']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ListPriceSchedule',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def priceschedules_post(self, price_schedule, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_post(price_schedule, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param PriceSchedule price_schedule:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.priceschedules_post_with_http_info(price_schedule, **kwargs)
        else:
            (data) = self.priceschedules_post_with_http_info(price_schedule, **kwargs)
            return data

    def priceschedules_post_with_http_info(self, price_schedule, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_post_with_http_info(price_schedule, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param PriceSchedule price_schedule:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method priceschedules_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule' is set
        if ('price_schedule' not in params) or (params['price_schedule'] is None):
            raise ValueError("Missing the required parameter `price_schedule` when calling `priceschedules_post`")

        resource_path = '/priceschedules'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'price_schedule' in params:
            body_params = params['price_schedule']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='PriceSchedule',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def priceschedules_price_schedule_id_delete(self, price_schedule_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_price_schedule_id_delete(price_schedule_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.priceschedules_price_schedule_id_delete_with_http_info(price_schedule_id, **kwargs)
        else:
            (data) = self.priceschedules_price_schedule_id_delete_with_http_info(price_schedule_id, **kwargs)
            return data

    def priceschedules_price_schedule_id_delete_with_http_info(self, price_schedule_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_price_schedule_id_delete_with_http_info(price_schedule_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method priceschedules_price_schedule_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule_id' is set
        if ('price_schedule_id' not in params) or (params['price_schedule_id'] is None):
            raise ValueError("Missing the required parameter `price_schedule_id` when calling `priceschedules_price_schedule_id_delete`")

        resource_path = '/priceschedules/{priceScheduleID}'.replace('{format}', 'json')
        path_params = {}
        if 'price_schedule_id' in params:
            path_params['priceScheduleID'] = params['price_schedule_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def priceschedules_price_schedule_id_get(self, price_schedule_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_price_schedule_id_get(price_schedule_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.priceschedules_price_schedule_id_get_with_http_info(price_schedule_id, **kwargs)
        else:
            (data) = self.priceschedules_price_schedule_id_get_with_http_info(price_schedule_id, **kwargs)
            return data

    def priceschedules_price_schedule_id_get_with_http_info(self, price_schedule_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_price_schedule_id_get_with_http_info(price_schedule_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method priceschedules_price_schedule_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule_id' is set
        if ('price_schedule_id' not in params) or (params['price_schedule_id'] is None):
            raise ValueError("Missing the required parameter `price_schedule_id` when calling `priceschedules_price_schedule_id_get`")

        resource_path = '/priceschedules/{priceScheduleID}'.replace('{format}', 'json')
        path_params = {}
        if 'price_schedule_id' in params:
            path_params['priceScheduleID'] = params['price_schedule_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='PriceSchedule',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def priceschedules_price_schedule_id_patch(self, price_schedule_id, price_schedule, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_price_schedule_id_patch(price_schedule_id, price_schedule, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param PriceSchedule price_schedule:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.priceschedules_price_schedule_id_patch_with_http_info(price_schedule_id, price_schedule, **kwargs)
        else:
            (data) = self.priceschedules_price_schedule_id_patch_with_http_info(price_schedule_id, price_schedule, **kwargs)
            return data

    def priceschedules_price_schedule_id_patch_with_http_info(self, price_schedule_id, price_schedule, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_price_schedule_id_patch_with_http_info(price_schedule_id, price_schedule, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param PriceSchedule price_schedule:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule_id', 'price_schedule']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method priceschedules_price_schedule_id_patch" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule_id' is set
        if ('price_schedule_id' not in params) or (params['price_schedule_id'] is None):
            raise ValueError("Missing the required parameter `price_schedule_id` when calling `priceschedules_price_schedule_id_patch`")
        # verify the required parameter 'price_schedule' is set
        if ('price_schedule' not in params) or (params['price_schedule'] is None):
            raise ValueError("Missing the required parameter `price_schedule` when calling `priceschedules_price_schedule_id_patch`")

        resource_path = '/priceschedules/{priceScheduleID}'.replace('{format}', 'json')
        path_params = {}
        if 'price_schedule_id' in params:
            path_params['priceScheduleID'] = params['price_schedule_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'price_schedule' in params:
            body_params = params['price_schedule']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'PATCH',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='PriceSchedule',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def priceschedules_price_schedule_id_price_breaks_delete(self, price_schedule_id, quantity, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_price_schedule_id_price_breaks_delete(price_schedule_id, quantity, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param int quantity: Quantity of the price schedule. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.priceschedules_price_schedule_id_price_breaks_delete_with_http_info(price_schedule_id, quantity, **kwargs)
        else:
            (data) = self.priceschedules_price_schedule_id_price_breaks_delete_with_http_info(price_schedule_id, quantity, **kwargs)
            return data

    def priceschedules_price_schedule_id_price_breaks_delete_with_http_info(self, price_schedule_id, quantity, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_price_schedule_id_price_breaks_delete_with_http_info(price_schedule_id, quantity, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param int quantity: Quantity of the price schedule. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule_id', 'quantity']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method priceschedules_price_schedule_id_price_breaks_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule_id' is set
        if ('price_schedule_id' not in params) or (params['price_schedule_id'] is None):
            raise ValueError("Missing the required parameter `price_schedule_id` when calling `priceschedules_price_schedule_id_price_breaks_delete`")
        # verify the required parameter 'quantity' is set
        if ('quantity' not in params) or (params['quantity'] is None):
            raise ValueError("Missing the required parameter `quantity` when calling `priceschedules_price_schedule_id_price_breaks_delete`")

        resource_path = '/priceschedules/{priceScheduleID}/PriceBreaks'.replace('{format}', 'json')
        path_params = {}
        if 'price_schedule_id' in params:
            path_params['priceScheduleID'] = params['price_schedule_id']

        query_params = {}
        if 'quantity' in params:
            query_params['quantity'] = params['quantity']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def priceschedules_price_schedule_id_price_breaks_post(self, price_schedule_id, price_break, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_price_schedule_id_price_breaks_post(price_schedule_id, price_break, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param PriceBreak price_break:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.priceschedules_price_schedule_id_price_breaks_post_with_http_info(price_schedule_id, price_break, **kwargs)
        else:
            (data) = self.priceschedules_price_schedule_id_price_breaks_post_with_http_info(price_schedule_id, price_break, **kwargs)
            return data

    def priceschedules_price_schedule_id_price_breaks_post_with_http_info(self, price_schedule_id, price_break, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_price_schedule_id_price_breaks_post_with_http_info(price_schedule_id, price_break, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param PriceBreak price_break:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule_id', 'price_break']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method priceschedules_price_schedule_id_price_breaks_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule_id' is set
        if ('price_schedule_id' not in params) or (params['price_schedule_id'] is None):
            raise ValueError("Missing the required parameter `price_schedule_id` when calling `priceschedules_price_schedule_id_price_breaks_post`")
        # verify the required parameter 'price_break' is set
        if ('price_break' not in params) or (params['price_break'] is None):
            raise ValueError("Missing the required parameter `price_break` when calling `priceschedules_price_schedule_id_price_breaks_post`")

        resource_path = '/priceschedules/{priceScheduleID}/PriceBreaks'.replace('{format}', 'json')
        path_params = {}
        if 'price_schedule_id' in params:
            path_params['priceScheduleID'] = params['price_schedule_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'price_break' in params:
            body_params = params['price_break']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='PriceSchedule',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def priceschedules_price_schedule_id_put(self, price_schedule_id, price_schedule, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_price_schedule_id_put(price_schedule_id, price_schedule, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param PriceSchedule price_schedule:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.priceschedules_price_schedule_id_put_with_http_info(price_schedule_id, price_schedule, **kwargs)
        else:
            (data) = self.priceschedules_price_schedule_id_put_with_http_info(price_schedule_id, price_schedule, **kwargs)
            return data

    def priceschedules_price_schedule_id_put_with_http_info(self, price_schedule_id, price_schedule, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.priceschedules_price_schedule_id_put_with_http_info(price_schedule_id, price_schedule, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param PriceSchedule price_schedule:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule_id', 'price_schedule']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method priceschedules_price_schedule_id_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule_id' is set
        if ('price_schedule_id' not in params) or (params['price_schedule_id'] is None):
            raise ValueError("Missing the required parameter `price_schedule_id` when calling `priceschedules_price_schedule_id_put`")
        # verify the required parameter 'price_schedule' is set
        if ('price_schedule' not in params) or (params['price_schedule'] is None):
            raise ValueError("Missing the required parameter `price_schedule` when calling `priceschedules_price_schedule_id_put`")

        resource_path = '/priceschedules/{priceScheduleID}'.replace('{format}', 'json')
        path_params = {}
        if 'price_schedule_id' in params:
            path_params['priceScheduleID'] = params['price_schedule_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'price_schedule' in params:
            body_params = params['price_schedule']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='PriceSchedule',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))
