# coding: utf-8

"""
    OrderCloud

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 1.0
    Contact: ordercloud@four51.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class ShipmentApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def shipments_get(self, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_get(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str order_id: ID of the order.
        :param str search: Search of the shipment.
        :param list[str] search_on: Search on of the shipment.
        :param list[str] sort_by: Sort by of the shipment.
        :param int page: Page of the shipment.
        :param int page_size: Page size of the shipment.
        :return: ListShipment
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.shipments_get_with_http_info(**kwargs)
        else:
            (data) = self.shipments_get_with_http_info(**kwargs)
            return data

    def shipments_get_with_http_info(self, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_get_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str order_id: ID of the order.
        :param str search: Search of the shipment.
        :param list[str] search_on: Search on of the shipment.
        :param list[str] sort_by: Sort by of the shipment.
        :param int page: Page of the shipment.
        :param int page_size: Page size of the shipment.
        :return: ListShipment
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['order_id', 'search', 'search_on', 'sort_by', 'page', 'page_size']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method shipments_get" % key
                )
            params[key] = val
        del params['kwargs']

        resource_path = '/shipments'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'order_id' in params:
            query_params['orderID'] = params['order_id']
        if 'search' in params:
            query_params['search'] = params['search']
        if 'search_on' in params:
            query_params['searchOn'] = params['search_on']
        if 'sort_by' in params:
            query_params['sortBy'] = params['sort_by']
        if 'page' in params:
            query_params['page'] = params['page']
        if 'page_size' in params:
            query_params['pageSize'] = params['page_size']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ListShipment',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def shipments_post(self, shipment, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_post(shipment, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Shipment shipment:  (required)
        :return: Shipment
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.shipments_post_with_http_info(shipment, **kwargs)
        else:
            (data) = self.shipments_post_with_http_info(shipment, **kwargs)
            return data

    def shipments_post_with_http_info(self, shipment, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_post_with_http_info(shipment, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Shipment shipment:  (required)
        :return: Shipment
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shipment']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method shipments_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shipment' is set
        if ('shipment' not in params) or (params['shipment'] is None):
            raise ValueError("Missing the required parameter `shipment` when calling `shipments_post`")

        resource_path = '/shipments'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'shipment' in params:
            body_params = params['shipment']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='Shipment',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def shipments_shipment_id_delete(self, shipment_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_delete(shipment_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.shipments_shipment_id_delete_with_http_info(shipment_id, **kwargs)
        else:
            (data) = self.shipments_shipment_id_delete_with_http_info(shipment_id, **kwargs)
            return data

    def shipments_shipment_id_delete_with_http_info(self, shipment_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_delete_with_http_info(shipment_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shipment_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method shipments_shipment_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shipment_id' is set
        if ('shipment_id' not in params) or (params['shipment_id'] is None):
            raise ValueError("Missing the required parameter `shipment_id` when calling `shipments_shipment_id_delete`")

        resource_path = '/shipments/{shipmentID}'.replace('{format}', 'json')
        path_params = {}
        if 'shipment_id' in params:
            path_params['shipmentID'] = params['shipment_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def shipments_shipment_id_get(self, shipment_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_get(shipment_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :return: Shipment
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.shipments_shipment_id_get_with_http_info(shipment_id, **kwargs)
        else:
            (data) = self.shipments_shipment_id_get_with_http_info(shipment_id, **kwargs)
            return data

    def shipments_shipment_id_get_with_http_info(self, shipment_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_get_with_http_info(shipment_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :return: Shipment
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shipment_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method shipments_shipment_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shipment_id' is set
        if ('shipment_id' not in params) or (params['shipment_id'] is None):
            raise ValueError("Missing the required parameter `shipment_id` when calling `shipments_shipment_id_get`")

        resource_path = '/shipments/{shipmentID}'.replace('{format}', 'json')
        path_params = {}
        if 'shipment_id' in params:
            path_params['shipmentID'] = params['shipment_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='Shipment',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def shipments_shipment_id_items_get(self, shipment_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_items_get(shipment_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :param str search: Search of the shipment.
        :param list[str] search_on: Search on of the shipment.
        :param list[str] sort_by: Sort by of the shipment.
        :param int page: Page of the shipment.
        :param int page_size: Page size of the shipment.
        :return: ListShipmentItem
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.shipments_shipment_id_items_get_with_http_info(shipment_id, **kwargs)
        else:
            (data) = self.shipments_shipment_id_items_get_with_http_info(shipment_id, **kwargs)
            return data

    def shipments_shipment_id_items_get_with_http_info(self, shipment_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_items_get_with_http_info(shipment_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :param str search: Search of the shipment.
        :param list[str] search_on: Search on of the shipment.
        :param list[str] sort_by: Sort by of the shipment.
        :param int page: Page of the shipment.
        :param int page_size: Page size of the shipment.
        :return: ListShipmentItem
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shipment_id', 'search', 'search_on', 'sort_by', 'page', 'page_size']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method shipments_shipment_id_items_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shipment_id' is set
        if ('shipment_id' not in params) or (params['shipment_id'] is None):
            raise ValueError("Missing the required parameter `shipment_id` when calling `shipments_shipment_id_items_get`")

        resource_path = '/shipments/{shipmentID}/items'.replace('{format}', 'json')
        path_params = {}
        if 'shipment_id' in params:
            path_params['shipmentID'] = params['shipment_id']

        query_params = {}
        if 'search' in params:
            query_params['search'] = params['search']
        if 'search_on' in params:
            query_params['searchOn'] = params['search_on']
        if 'sort_by' in params:
            query_params['sortBy'] = params['sort_by']
        if 'page' in params:
            query_params['page'] = params['page']
        if 'page_size' in params:
            query_params['pageSize'] = params['page_size']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ListShipmentItem',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def shipments_shipment_id_items_order_id_line_item_id_delete(self, shipment_id, order_id, line_item_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_items_order_id_line_item_id_delete(shipment_id, order_id, line_item_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :param str order_id: ID of the order. (required)
        :param str line_item_id: ID of the line item. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.shipments_shipment_id_items_order_id_line_item_id_delete_with_http_info(shipment_id, order_id, line_item_id, **kwargs)
        else:
            (data) = self.shipments_shipment_id_items_order_id_line_item_id_delete_with_http_info(shipment_id, order_id, line_item_id, **kwargs)
            return data

    def shipments_shipment_id_items_order_id_line_item_id_delete_with_http_info(self, shipment_id, order_id, line_item_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_items_order_id_line_item_id_delete_with_http_info(shipment_id, order_id, line_item_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :param str order_id: ID of the order. (required)
        :param str line_item_id: ID of the line item. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shipment_id', 'order_id', 'line_item_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method shipments_shipment_id_items_order_id_line_item_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shipment_id' is set
        if ('shipment_id' not in params) or (params['shipment_id'] is None):
            raise ValueError("Missing the required parameter `shipment_id` when calling `shipments_shipment_id_items_order_id_line_item_id_delete`")
        # verify the required parameter 'order_id' is set
        if ('order_id' not in params) or (params['order_id'] is None):
            raise ValueError("Missing the required parameter `order_id` when calling `shipments_shipment_id_items_order_id_line_item_id_delete`")
        # verify the required parameter 'line_item_id' is set
        if ('line_item_id' not in params) or (params['line_item_id'] is None):
            raise ValueError("Missing the required parameter `line_item_id` when calling `shipments_shipment_id_items_order_id_line_item_id_delete`")

        resource_path = '/shipments/{shipmentID}/items/{orderID}/{lineItemID}'.replace('{format}', 'json')
        path_params = {}
        if 'shipment_id' in params:
            path_params['shipmentID'] = params['shipment_id']
        if 'order_id' in params:
            path_params['orderID'] = params['order_id']
        if 'line_item_id' in params:
            path_params['lineItemID'] = params['line_item_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def shipments_shipment_id_items_order_id_line_item_id_get(self, shipment_id, order_id, line_item_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_items_order_id_line_item_id_get(shipment_id, order_id, line_item_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :param str order_id: ID of the order. (required)
        :param str line_item_id: ID of the line item. (required)
        :return: ShipmentItem
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.shipments_shipment_id_items_order_id_line_item_id_get_with_http_info(shipment_id, order_id, line_item_id, **kwargs)
        else:
            (data) = self.shipments_shipment_id_items_order_id_line_item_id_get_with_http_info(shipment_id, order_id, line_item_id, **kwargs)
            return data

    def shipments_shipment_id_items_order_id_line_item_id_get_with_http_info(self, shipment_id, order_id, line_item_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_items_order_id_line_item_id_get_with_http_info(shipment_id, order_id, line_item_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :param str order_id: ID of the order. (required)
        :param str line_item_id: ID of the line item. (required)
        :return: ShipmentItem
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shipment_id', 'order_id', 'line_item_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method shipments_shipment_id_items_order_id_line_item_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shipment_id' is set
        if ('shipment_id' not in params) or (params['shipment_id'] is None):
            raise ValueError("Missing the required parameter `shipment_id` when calling `shipments_shipment_id_items_order_id_line_item_id_get`")
        # verify the required parameter 'order_id' is set
        if ('order_id' not in params) or (params['order_id'] is None):
            raise ValueError("Missing the required parameter `order_id` when calling `shipments_shipment_id_items_order_id_line_item_id_get`")
        # verify the required parameter 'line_item_id' is set
        if ('line_item_id' not in params) or (params['line_item_id'] is None):
            raise ValueError("Missing the required parameter `line_item_id` when calling `shipments_shipment_id_items_order_id_line_item_id_get`")

        resource_path = '/shipments/{shipmentID}/items/{orderID}/{lineItemID}'.replace('{format}', 'json')
        path_params = {}
        if 'shipment_id' in params:
            path_params['shipmentID'] = params['shipment_id']
        if 'order_id' in params:
            path_params['orderID'] = params['order_id']
        if 'line_item_id' in params:
            path_params['lineItemID'] = params['line_item_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ShipmentItem',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def shipments_shipment_id_items_post(self, shipment_id, item, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_items_post(shipment_id, item, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :param ShipmentItem item:  (required)
        :return: ShipmentItem
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.shipments_shipment_id_items_post_with_http_info(shipment_id, item, **kwargs)
        else:
            (data) = self.shipments_shipment_id_items_post_with_http_info(shipment_id, item, **kwargs)
            return data

    def shipments_shipment_id_items_post_with_http_info(self, shipment_id, item, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_items_post_with_http_info(shipment_id, item, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :param ShipmentItem item:  (required)
        :return: ShipmentItem
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shipment_id', 'item']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method shipments_shipment_id_items_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shipment_id' is set
        if ('shipment_id' not in params) or (params['shipment_id'] is None):
            raise ValueError("Missing the required parameter `shipment_id` when calling `shipments_shipment_id_items_post`")
        # verify the required parameter 'item' is set
        if ('item' not in params) or (params['item'] is None):
            raise ValueError("Missing the required parameter `item` when calling `shipments_shipment_id_items_post`")

        resource_path = '/shipments/{shipmentID}/items'.replace('{format}', 'json')
        path_params = {}
        if 'shipment_id' in params:
            path_params['shipmentID'] = params['shipment_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'item' in params:
            body_params = params['item']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ShipmentItem',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def shipments_shipment_id_patch(self, shipment_id, shipment, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_patch(shipment_id, shipment, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :param Shipment shipment:  (required)
        :return: Shipment
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.shipments_shipment_id_patch_with_http_info(shipment_id, shipment, **kwargs)
        else:
            (data) = self.shipments_shipment_id_patch_with_http_info(shipment_id, shipment, **kwargs)
            return data

    def shipments_shipment_id_patch_with_http_info(self, shipment_id, shipment, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_patch_with_http_info(shipment_id, shipment, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :param Shipment shipment:  (required)
        :return: Shipment
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shipment_id', 'shipment']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method shipments_shipment_id_patch" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shipment_id' is set
        if ('shipment_id' not in params) or (params['shipment_id'] is None):
            raise ValueError("Missing the required parameter `shipment_id` when calling `shipments_shipment_id_patch`")
        # verify the required parameter 'shipment' is set
        if ('shipment' not in params) or (params['shipment'] is None):
            raise ValueError("Missing the required parameter `shipment` when calling `shipments_shipment_id_patch`")

        resource_path = '/shipments/{shipmentID}'.replace('{format}', 'json')
        path_params = {}
        if 'shipment_id' in params:
            path_params['shipmentID'] = params['shipment_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'shipment' in params:
            body_params = params['shipment']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'PATCH',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='Shipment',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def shipments_shipment_id_put(self, shipment_id, shipment, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_put(shipment_id, shipment, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :param Shipment shipment:  (required)
        :return: Shipment
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.shipments_shipment_id_put_with_http_info(shipment_id, shipment, **kwargs)
        else:
            (data) = self.shipments_shipment_id_put_with_http_info(shipment_id, shipment, **kwargs)
            return data

    def shipments_shipment_id_put_with_http_info(self, shipment_id, shipment, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.shipments_shipment_id_put_with_http_info(shipment_id, shipment, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str shipment_id: ID of the shipment. (required)
        :param Shipment shipment:  (required)
        :return: Shipment
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['shipment_id', 'shipment']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method shipments_shipment_id_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'shipment_id' is set
        if ('shipment_id' not in params) or (params['shipment_id'] is None):
            raise ValueError("Missing the required parameter `shipment_id` when calling `shipments_shipment_id_put`")
        # verify the required parameter 'shipment' is set
        if ('shipment' not in params) or (params['shipment'] is None):
            raise ValueError("Missing the required parameter `shipment` when calling `shipments_shipment_id_put`")

        resource_path = '/shipments/{shipmentID}'.replace('{format}', 'json')
        path_params = {}
        if 'shipment_id' in params:
            path_params['shipmentID'] = params['shipment_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'shipment' in params:
            body_params = params['shipment']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='Shipment',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))
