# coding: utf-8

"""
    OrderCloud

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 1.0
    Contact: ordercloud@four51.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class SpecApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def specs_get(self, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_get(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str search: Search of the spec.
        :param list[str] search_on: Search on of the spec.
        :param list[str] sort_by: Sort by of the spec.
        :param int page: Page of the spec.
        :param int page_size: Page size of the spec.
        :return: ListSpec
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_get_with_http_info(**kwargs)
        else:
            (data) = self.specs_get_with_http_info(**kwargs)
            return data

    def specs_get_with_http_info(self, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_get_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str search: Search of the spec.
        :param list[str] search_on: Search on of the spec.
        :param list[str] sort_by: Sort by of the spec.
        :param int page: Page of the spec.
        :param int page_size: Page size of the spec.
        :return: ListSpec
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['search', 'search_on', 'sort_by', 'page', 'page_size']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_get" % key
                )
            params[key] = val
        del params['kwargs']

        resource_path = '/specs'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'search' in params:
            query_params['search'] = params['search']
        if 'search_on' in params:
            query_params['searchOn'] = params['search_on']
        if 'sort_by' in params:
            query_params['sortBy'] = params['sort_by']
        if 'page' in params:
            query_params['page'] = params['page']
        if 'page_size' in params:
            query_params['pageSize'] = params['page_size']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ListSpec',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_post(self, spec, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_post(spec, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Spec spec:  (required)
        :return: Spec
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_post_with_http_info(spec, **kwargs)
        else:
            (data) = self.specs_post_with_http_info(spec, **kwargs)
            return data

    def specs_post_with_http_info(self, spec, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_post_with_http_info(spec, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Spec spec:  (required)
        :return: Spec
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['spec']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'spec' is set
        if ('spec' not in params) or (params['spec'] is None):
            raise ValueError("Missing the required parameter `spec` when calling `specs_post`")

        resource_path = '/specs'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'spec' in params:
            body_params = params['spec']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='Spec',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_productassignments_get(self, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_productassignments_get(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str search: Search of the spec.
        :param list[str] search_on: Search on of the spec.
        :param list[str] sort_by: Sort by of the spec.
        :param int page: Page of the spec.
        :param int page_size: Page size of the spec.
        :return: ListSpecProductAssignment
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_productassignments_get_with_http_info(**kwargs)
        else:
            (data) = self.specs_productassignments_get_with_http_info(**kwargs)
            return data

    def specs_productassignments_get_with_http_info(self, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_productassignments_get_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str search: Search of the spec.
        :param list[str] search_on: Search on of the spec.
        :param list[str] sort_by: Sort by of the spec.
        :param int page: Page of the spec.
        :param int page_size: Page size of the spec.
        :return: ListSpecProductAssignment
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['search', 'search_on', 'sort_by', 'page', 'page_size']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_productassignments_get" % key
                )
            params[key] = val
        del params['kwargs']

        resource_path = '/specs/productassignments'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'search' in params:
            query_params['search'] = params['search']
        if 'search_on' in params:
            query_params['searchOn'] = params['search_on']
        if 'sort_by' in params:
            query_params['sortBy'] = params['sort_by']
        if 'page' in params:
            query_params['page'] = params['page']
        if 'page_size' in params:
            query_params['pageSize'] = params['page_size']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ListSpecProductAssignment',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_productassignments_post(self, product_assignment, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_productassignments_post(product_assignment, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param SpecProductAssignment product_assignment:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_productassignments_post_with_http_info(product_assignment, **kwargs)
        else:
            (data) = self.specs_productassignments_post_with_http_info(product_assignment, **kwargs)
            return data

    def specs_productassignments_post_with_http_info(self, product_assignment, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_productassignments_post_with_http_info(product_assignment, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param SpecProductAssignment product_assignment:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['product_assignment']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_productassignments_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'product_assignment' is set
        if ('product_assignment' not in params) or (params['product_assignment'] is None):
            raise ValueError("Missing the required parameter `product_assignment` when calling `specs_productassignments_post`")

        resource_path = '/specs/productassignments'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'product_assignment' in params:
            body_params = params['product_assignment']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_spec_id_delete(self, spec_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_delete(spec_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_spec_id_delete_with_http_info(spec_id, **kwargs)
        else:
            (data) = self.specs_spec_id_delete_with_http_info(spec_id, **kwargs)
            return data

    def specs_spec_id_delete_with_http_info(self, spec_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_delete_with_http_info(spec_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['spec_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_spec_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'spec_id' is set
        if ('spec_id' not in params) or (params['spec_id'] is None):
            raise ValueError("Missing the required parameter `spec_id` when calling `specs_spec_id_delete`")

        resource_path = '/specs/{specID}'.replace('{format}', 'json')
        path_params = {}
        if 'spec_id' in params:
            path_params['specID'] = params['spec_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_spec_id_get(self, spec_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_get(spec_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :return: Spec
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_spec_id_get_with_http_info(spec_id, **kwargs)
        else:
            (data) = self.specs_spec_id_get_with_http_info(spec_id, **kwargs)
            return data

    def specs_spec_id_get_with_http_info(self, spec_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_get_with_http_info(spec_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :return: Spec
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['spec_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_spec_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'spec_id' is set
        if ('spec_id' not in params) or (params['spec_id'] is None):
            raise ValueError("Missing the required parameter `spec_id` when calling `specs_spec_id_get`")

        resource_path = '/specs/{specID}'.replace('{format}', 'json')
        path_params = {}
        if 'spec_id' in params:
            path_params['specID'] = params['spec_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='Spec',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_spec_id_options_get(self, spec_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_options_get(spec_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param str search: Search of the spec.
        :param list[str] search_on: Search on of the spec.
        :param list[str] sort_by: Sort by of the spec.
        :param int page: Page of the spec.
        :param int page_size: Page size of the spec.
        :return: ListSpecOption
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_spec_id_options_get_with_http_info(spec_id, **kwargs)
        else:
            (data) = self.specs_spec_id_options_get_with_http_info(spec_id, **kwargs)
            return data

    def specs_spec_id_options_get_with_http_info(self, spec_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_options_get_with_http_info(spec_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param str search: Search of the spec.
        :param list[str] search_on: Search on of the spec.
        :param list[str] sort_by: Sort by of the spec.
        :param int page: Page of the spec.
        :param int page_size: Page size of the spec.
        :return: ListSpecOption
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['spec_id', 'search', 'search_on', 'sort_by', 'page', 'page_size']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_spec_id_options_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'spec_id' is set
        if ('spec_id' not in params) or (params['spec_id'] is None):
            raise ValueError("Missing the required parameter `spec_id` when calling `specs_spec_id_options_get`")

        resource_path = '/specs/{specID}/options'.replace('{format}', 'json')
        path_params = {}
        if 'spec_id' in params:
            path_params['specID'] = params['spec_id']

        query_params = {}
        if 'search' in params:
            query_params['search'] = params['search']
        if 'search_on' in params:
            query_params['searchOn'] = params['search_on']
        if 'sort_by' in params:
            query_params['sortBy'] = params['sort_by']
        if 'page' in params:
            query_params['page'] = params['page']
        if 'page_size' in params:
            query_params['pageSize'] = params['page_size']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ListSpecOption',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_spec_id_options_option_id_delete(self, spec_id, option_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_options_option_id_delete(spec_id, option_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param str option_id: ID of the option. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_spec_id_options_option_id_delete_with_http_info(spec_id, option_id, **kwargs)
        else:
            (data) = self.specs_spec_id_options_option_id_delete_with_http_info(spec_id, option_id, **kwargs)
            return data

    def specs_spec_id_options_option_id_delete_with_http_info(self, spec_id, option_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_options_option_id_delete_with_http_info(spec_id, option_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param str option_id: ID of the option. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['spec_id', 'option_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_spec_id_options_option_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'spec_id' is set
        if ('spec_id' not in params) or (params['spec_id'] is None):
            raise ValueError("Missing the required parameter `spec_id` when calling `specs_spec_id_options_option_id_delete`")
        # verify the required parameter 'option_id' is set
        if ('option_id' not in params) or (params['option_id'] is None):
            raise ValueError("Missing the required parameter `option_id` when calling `specs_spec_id_options_option_id_delete`")

        resource_path = '/specs/{specID}/options/{optionID}'.replace('{format}', 'json')
        path_params = {}
        if 'spec_id' in params:
            path_params['specID'] = params['spec_id']
        if 'option_id' in params:
            path_params['optionID'] = params['option_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_spec_id_options_option_id_get(self, spec_id, option_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_options_option_id_get(spec_id, option_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param str option_id: ID of the option. (required)
        :return: SpecOption
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_spec_id_options_option_id_get_with_http_info(spec_id, option_id, **kwargs)
        else:
            (data) = self.specs_spec_id_options_option_id_get_with_http_info(spec_id, option_id, **kwargs)
            return data

    def specs_spec_id_options_option_id_get_with_http_info(self, spec_id, option_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_options_option_id_get_with_http_info(spec_id, option_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param str option_id: ID of the option. (required)
        :return: SpecOption
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['spec_id', 'option_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_spec_id_options_option_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'spec_id' is set
        if ('spec_id' not in params) or (params['spec_id'] is None):
            raise ValueError("Missing the required parameter `spec_id` when calling `specs_spec_id_options_option_id_get`")
        # verify the required parameter 'option_id' is set
        if ('option_id' not in params) or (params['option_id'] is None):
            raise ValueError("Missing the required parameter `option_id` when calling `specs_spec_id_options_option_id_get`")

        resource_path = '/specs/{specID}/options/{optionID}'.replace('{format}', 'json')
        path_params = {}
        if 'spec_id' in params:
            path_params['specID'] = params['spec_id']
        if 'option_id' in params:
            path_params['optionID'] = params['option_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='SpecOption',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_spec_id_options_option_id_patch(self, spec_id, option_id, option, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_options_option_id_patch(spec_id, option_id, option, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param str option_id: ID of the option. (required)
        :param SpecOption option:  (required)
        :return: SpecOption
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_spec_id_options_option_id_patch_with_http_info(spec_id, option_id, option, **kwargs)
        else:
            (data) = self.specs_spec_id_options_option_id_patch_with_http_info(spec_id, option_id, option, **kwargs)
            return data

    def specs_spec_id_options_option_id_patch_with_http_info(self, spec_id, option_id, option, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_options_option_id_patch_with_http_info(spec_id, option_id, option, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param str option_id: ID of the option. (required)
        :param SpecOption option:  (required)
        :return: SpecOption
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['spec_id', 'option_id', 'option']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_spec_id_options_option_id_patch" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'spec_id' is set
        if ('spec_id' not in params) or (params['spec_id'] is None):
            raise ValueError("Missing the required parameter `spec_id` when calling `specs_spec_id_options_option_id_patch`")
        # verify the required parameter 'option_id' is set
        if ('option_id' not in params) or (params['option_id'] is None):
            raise ValueError("Missing the required parameter `option_id` when calling `specs_spec_id_options_option_id_patch`")
        # verify the required parameter 'option' is set
        if ('option' not in params) or (params['option'] is None):
            raise ValueError("Missing the required parameter `option` when calling `specs_spec_id_options_option_id_patch`")

        resource_path = '/specs/{specID}/options/{optionID}'.replace('{format}', 'json')
        path_params = {}
        if 'spec_id' in params:
            path_params['specID'] = params['spec_id']
        if 'option_id' in params:
            path_params['optionID'] = params['option_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'option' in params:
            body_params = params['option']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'PATCH',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='SpecOption',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_spec_id_options_option_id_put(self, spec_id, option_id, option, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_options_option_id_put(spec_id, option_id, option, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param str option_id: ID of the option. (required)
        :param SpecOption option:  (required)
        :return: SpecOption
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_spec_id_options_option_id_put_with_http_info(spec_id, option_id, option, **kwargs)
        else:
            (data) = self.specs_spec_id_options_option_id_put_with_http_info(spec_id, option_id, option, **kwargs)
            return data

    def specs_spec_id_options_option_id_put_with_http_info(self, spec_id, option_id, option, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_options_option_id_put_with_http_info(spec_id, option_id, option, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param str option_id: ID of the option. (required)
        :param SpecOption option:  (required)
        :return: SpecOption
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['spec_id', 'option_id', 'option']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_spec_id_options_option_id_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'spec_id' is set
        if ('spec_id' not in params) or (params['spec_id'] is None):
            raise ValueError("Missing the required parameter `spec_id` when calling `specs_spec_id_options_option_id_put`")
        # verify the required parameter 'option_id' is set
        if ('option_id' not in params) or (params['option_id'] is None):
            raise ValueError("Missing the required parameter `option_id` when calling `specs_spec_id_options_option_id_put`")
        # verify the required parameter 'option' is set
        if ('option' not in params) or (params['option'] is None):
            raise ValueError("Missing the required parameter `option` when calling `specs_spec_id_options_option_id_put`")

        resource_path = '/specs/{specID}/options/{optionID}'.replace('{format}', 'json')
        path_params = {}
        if 'spec_id' in params:
            path_params['specID'] = params['spec_id']
        if 'option_id' in params:
            path_params['optionID'] = params['option_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'option' in params:
            body_params = params['option']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='SpecOption',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_spec_id_options_post(self, spec_id, option, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_options_post(spec_id, option, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param SpecOption option:  (required)
        :return: SpecOption
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_spec_id_options_post_with_http_info(spec_id, option, **kwargs)
        else:
            (data) = self.specs_spec_id_options_post_with_http_info(spec_id, option, **kwargs)
            return data

    def specs_spec_id_options_post_with_http_info(self, spec_id, option, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_options_post_with_http_info(spec_id, option, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param SpecOption option:  (required)
        :return: SpecOption
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['spec_id', 'option']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_spec_id_options_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'spec_id' is set
        if ('spec_id' not in params) or (params['spec_id'] is None):
            raise ValueError("Missing the required parameter `spec_id` when calling `specs_spec_id_options_post`")
        # verify the required parameter 'option' is set
        if ('option' not in params) or (params['option'] is None):
            raise ValueError("Missing the required parameter `option` when calling `specs_spec_id_options_post`")

        resource_path = '/specs/{specID}/options'.replace('{format}', 'json')
        path_params = {}
        if 'spec_id' in params:
            path_params['specID'] = params['spec_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'option' in params:
            body_params = params['option']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='SpecOption',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_spec_id_patch(self, spec_id, spec, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_patch(spec_id, spec, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param Spec spec:  (required)
        :return: Spec
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_spec_id_patch_with_http_info(spec_id, spec, **kwargs)
        else:
            (data) = self.specs_spec_id_patch_with_http_info(spec_id, spec, **kwargs)
            return data

    def specs_spec_id_patch_with_http_info(self, spec_id, spec, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_patch_with_http_info(spec_id, spec, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param Spec spec:  (required)
        :return: Spec
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['spec_id', 'spec']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_spec_id_patch" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'spec_id' is set
        if ('spec_id' not in params) or (params['spec_id'] is None):
            raise ValueError("Missing the required parameter `spec_id` when calling `specs_spec_id_patch`")
        # verify the required parameter 'spec' is set
        if ('spec' not in params) or (params['spec'] is None):
            raise ValueError("Missing the required parameter `spec` when calling `specs_spec_id_patch`")

        resource_path = '/specs/{specID}'.replace('{format}', 'json')
        path_params = {}
        if 'spec_id' in params:
            path_params['specID'] = params['spec_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'spec' in params:
            body_params = params['spec']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'PATCH',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='Spec',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_spec_id_productassignments_product_id_delete(self, spec_id, product_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_productassignments_product_id_delete(spec_id, product_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param str product_id: ID of the product. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_spec_id_productassignments_product_id_delete_with_http_info(spec_id, product_id, **kwargs)
        else:
            (data) = self.specs_spec_id_productassignments_product_id_delete_with_http_info(spec_id, product_id, **kwargs)
            return data

    def specs_spec_id_productassignments_product_id_delete_with_http_info(self, spec_id, product_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_productassignments_product_id_delete_with_http_info(spec_id, product_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param str product_id: ID of the product. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['spec_id', 'product_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_spec_id_productassignments_product_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'spec_id' is set
        if ('spec_id' not in params) or (params['spec_id'] is None):
            raise ValueError("Missing the required parameter `spec_id` when calling `specs_spec_id_productassignments_product_id_delete`")
        # verify the required parameter 'product_id' is set
        if ('product_id' not in params) or (params['product_id'] is None):
            raise ValueError("Missing the required parameter `product_id` when calling `specs_spec_id_productassignments_product_id_delete`")

        resource_path = '/specs/{specID}/productassignments/{productID}'.replace('{format}', 'json')
        path_params = {}
        if 'spec_id' in params:
            path_params['specID'] = params['spec_id']
        if 'product_id' in params:
            path_params['productID'] = params['product_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def specs_spec_id_put(self, spec_id, spec, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_put(spec_id, spec, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param Spec spec:  (required)
        :return: Spec
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.specs_spec_id_put_with_http_info(spec_id, spec, **kwargs)
        else:
            (data) = self.specs_spec_id_put_with_http_info(spec_id, spec, **kwargs)
            return data

    def specs_spec_id_put_with_http_info(self, spec_id, spec, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.specs_spec_id_put_with_http_info(spec_id, spec, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str spec_id: ID of the spec. (required)
        :param Spec spec:  (required)
        :return: Spec
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['spec_id', 'spec']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method specs_spec_id_put" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'spec_id' is set
        if ('spec_id' not in params) or (params['spec_id'] is None):
            raise ValueError("Missing the required parameter `spec_id` when calling `specs_spec_id_put`")
        # verify the required parameter 'spec' is set
        if ('spec' not in params) or (params['spec'] is None):
            raise ValueError("Missing the required parameter `spec` when calling `specs_spec_id_put`")

        resource_path = '/specs/{specID}'.replace('{format}', 'json')
        path_params = {}
        if 'spec_id' in params:
            path_params['specID'] = params['spec_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'spec' in params:
            body_params = params['spec']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='Spec',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))
